# std::filesystem::read_symlink

From cppreference.com
< cpp‎ | filesystem

Defined in header `<filesystem>` |  |
std::filesystem::path read_symlink(const std::filesystem::path & p); std::filesystem::path read_symlink(const std::filesystem::path & p, std::error_code & ec); |  | (since C++17)

If the path `p` refers to a symbolic link, returns a new path object which refers to the target of that symbolic link.

It is an error if `p` does not refer to a symbolic link.

The non-throwing overload returns an empty path on errors.

### Parameters

p | - | path to a symlink
ec | - | out-parameter for error reporting in the non-throwing overload

### Return value

The target of the symlink (which may not necessarily exist)

### Exceptions

The overload that does not take a std::error_code & parameter throws `filesystem_error` on underlying OS API errors, constructed with `p` as the first path argument and the OS error code as the error code argument. The overload taking a std::error_code & parameter sets it to the OS API error code if an OS API call fails, and executes ec.clear() if no errors occur. Any overload not marked `noexcept` may throw std::bad_alloc if memory allocation fails.

### Example

Run this code

    #include <iostream>
    #include <filesystem>

    namespace fs = std::filesystem;

    int main()
    {
        // on a typical Linux system, /lib/libc.so.6 is a symlink
        fs::path p = "/lib/libc.so.6";
        if(fs::exists(p) && fs::is_symlink(p))
            std::cout << p << " -> " << fs::read_symlink(p) << '\n';
        else
            std::cout << p << " does not exist or is not a symlink\n";
    }

Possible output:

    "/lib/libc.so.6" -> "libc-2.12.so"

### See also

is_symlink (C++17) | checks whether the argument refers to a symbolic link (function)
create_symlinkcreate_directory_symlink (C++17)(C++17) | creates a symbolic link (function)
copy_symlink (C++17) | copies a symbolic link (function)
statussymlink_status (C++17)(C++17) | determines file attributes determines file attributes, checking the symlink target (function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/filesystem/read_symlink&oldid=105089"